execute as @e[type=minecraft:item_display,tag=horseshoes.horseshoe_display] at @e[type=minecraft:armor_stand,tag=horseshoes.horseshoe] if score @s horseshoes.uuid_least = @n[type=minecraft:armor_stand,tag=horseshoes.horseshoe] horseshoes.uuid_least if score @s horseshoes.uuid_most = @n[type=minecraft:armor_stand,tag=horseshoes.horseshoe] horseshoes.uuid_most run tp @s ~ ~.05 ~
execute as @e[type=minecraft:item_display,tag=horseshoes.horseshoe_display] at @e[type=minecraft:armor_stand,tag=horseshoes.horseshoe] if score @s horseshoes.uuid_least = @n[type=minecraft:armor_stand,tag=horseshoes.horseshoe] horseshoes.uuid_least if score @s horseshoes.uuid_most = @n[type=minecraft:armor_stand,tag=horseshoes.horseshoe] horseshoes.uuid_most run tag @s add horseshoes.keep_alive

execute as @e[type=minecraft:item_display,tag=horseshoes.horseshoe_display] at @s if block ~ ~-1 ~ #minecraft:air rotated as @s run tp @s ~ ~ ~ ~50 ~

kill @e[type=minecraft:item_display,tag=horseshoes.horseshoe_display,tag=!horseshoes.keep_alive]
tag @e[type=minecraft:item_display,tag=horseshoes.horseshoe_display] remove horseshoes.keep_alive

execute as @e[type=minecraft:armor_stand,tag=horseshoes.horseshoe,nbt={OnGround:false},tag=!horseshoes.hit] at @s if entity @e[type=!minecraft:armor_stand,type=!minecraft:item_display,distance=..1] run function horseshoes:hit

execute as @e[type=minecraft:armor_stand,tag=horseshoes.horseshoe] at @s if entity @a[distance=..1] run function horseshoes:pickup_horseshoe

execute as @e[type=minecraft:horse, nbt={body_armor_item:{id:"minecraft:copper_ingot",components:{"minecraft:item_model": "horseshoes:copper_horseshoe"}}}] run effect give @s minecraft:jump_boost 1 2 true

# sprint:
# if the player presses sprint, give the horse a speed boost
execute as @e[type=minecraft:horse, nbt={body_armor_item:{id:"minecraft:copper_ingot",components:{"minecraft:item_model": "horseshoes:copper_horseshoe"}}}] on passengers if predicate horseshoes:sprint on vehicle run effect give @s minecraft:speed 1 3 true

# horseshoes take damage as you ride (4% chance for every block traveled)
execute as @e[type=minecraft:horse, nbt={body_armor_item:{id:"minecraft:copper_ingot",components:{"minecraft:item_model": "horseshoes:copper_horseshoe"}}}] on passengers if score @s horseshoes.distance_a matches 100.. if predicate { condition: "minecraft:random_chance", chance: 0.04 } on vehicle run item modify entity @s armor.body horseshoes:damage
execute as @e[type=minecraft:horse, nbt={body_armor_item:{id:"minecraft:copper_ingot",components:{"minecraft:item_model": "horseshoes:copper_horseshoe"}}}] at @s run stopsound @a[distance=..8] * minecraft:item.armor.equip_generic
execute as @e[type=minecraft:horse, nbt={body_armor_item:{id:"minecraft:copper_ingot",components:{"minecraft:item_model": "horseshoes:copper_horseshoe"}}}] on passengers if score @s horseshoes.distance_a matches 100.. run scoreboard players reset @s horseshoes.distance_a
execute as @e[type=minecraft:horse, nbt={body_armor_item:{id:"minecraft:copper_ingot",components:{"minecraft:item_model": "horseshoes:copper_horseshoe", "minecraft:damage": 100}}}] at @s run playsound minecraft:entity.item.break neutral @a ~ ~ ~
execute as @e[type=minecraft:horse, nbt={body_armor_item:{id:"minecraft:copper_ingot",components:{"minecraft:item_model": "horseshoes:copper_horseshoe", "minecraft:damage": 100}}}] run item replace entity @s armor.body with minecraft:air

# if the player dismounts, reset their scoreboard
execute as @a unless predicate { condition: "minecraft:entity_properties", entity: "this", predicate: { vehicle: { type: "minecraft:horse" } } } run scoreboard players reset @s horseshoes.distance_a

# trample logic:
# if a horse is in the air, has a passenger, and collides with another entity, deal a small amount of damage
execute as @e[type=minecraft:horse, nbt={OnGround:true}] on passengers at @s as @n[type=!minecraft:horse, distance=..1] run damage @s 1

# frost walker:
execute as @e[type=minecraft:horse, nbt={body_armor_item:{id:"minecraft:copper_ingot",components:{"minecraft:item_model": "horseshoes:copper_horseshoe"}}}] at @s anchored feet positioned ~ ~-1 ~ run function horseshoes:frost_walker